package solutions.bitbadger.documents.groovy

import org.junit.jupiter.api.DisplayName
import org.junit.jupiter.api.Test
import solutions.bitbadger.documents.Op

import static groovy.test.GroovyAssert.*

/**
 * Unit tests for the `Op` enum
 */
@DisplayName('JVM | Groovy | Op')
class OpTest {

    @Test
    @DisplayName('EQUAL uses proper SQL')
    void equalSQL() {
        assertEquals('The SQL for equal is incorrect', '=', Op.EQUAL.sql)
    }

    @Test
    @DisplayName('GREATER uses proper SQL')
    void greaterSQL() {
        assertEquals('The SQL for greater is incorrect', '>', Op.GREATER.sql)
    }

    @Test
    @DisplayName('GREATER_OR_EQUAL uses proper SQL')
    void greaterOrEqualSQL() {
        assertEquals('The SQL for greater-or-equal is incorrect', '>=', Op.GREATER_OR_EQUAL.sql)
    }

    @Test
    @DisplayName('LESS uses proper SQL')
    void lessSQL() {
        assertEquals('The SQL for less is incorrect', '<', Op.LESS.sql)
    }

    @Test
    @DisplayName('LESS_OR_EQUAL uses proper SQL')
    void lessOrEqualSQL() {
        assertEquals('The SQL for less-or-equal is incorrect', '<=', Op.LESS_OR_EQUAL.sql)
    }

    @Test
    @DisplayName('NOT_EQUAL uses proper SQL')
    void notEqualSQL() {
        assertEquals('The SQL for not-equal is incorrect', '<>', Op.NOT_EQUAL.sql)
    }

    @Test
    @DisplayName('BETWEEN uses proper SQL')
    void betweenSQL() {
        assertEquals('The SQL for between is incorrect', 'BETWEEN', Op.BETWEEN.sql)
    }

    @Test
    @DisplayName('IN uses proper SQL')
    void inSQL() {
        assertEquals('The SQL for in is incorrect', 'IN', Op.IN.sql)
    }

    @Test
    @DisplayName('IN_ARRAY uses proper SQL')
    void inArraySQL() {
        assertEquals('The SQL for in-array is incorrect', '??|', Op.IN_ARRAY.sql)
    }

    @Test
    @DisplayName('EXISTS uses proper SQL')
    void existsSQL() {
        assertEquals('The SQL for exists is incorrect', 'IS NOT NULL', Op.EXISTS.sql)
    }

    @Test
    @DisplayName('NOT_EXISTS uses proper SQL')
    void notExistsSQL() {
        assertEquals('The SQL for not-exists is incorrect', 'IS NULL', Op.NOT_EXISTS.sql)
    }
}
