package solutions.bitbadger.documents.groovy

import org.junit.jupiter.api.DisplayName
import org.junit.jupiter.api.Test
import solutions.bitbadger.documents.ParameterName
import static groovy.test.GroovyAssert.assertEquals
/**
 * Unit tests for the `ParameterName` class
 */
@DisplayName('JVM | Groovy | ParameterName')
class ParameterNameTest {

    @Test
    @DisplayName('derive works when given existing names')
    void withExisting() {
        def names = new ParameterName()
        assertEquals('Name should have been :taco', ':taco', names.derive(':taco'))
        assertEquals('Counter should not have advanced for named field', ':field0', names.derive(null))
    }

    @Test
    @DisplayName('derive works when given all anonymous fields')
    void allAnonymous() {
        def names = new ParameterName()
        assertEquals('Anonymous field name should have been returned', ':field0', names.derive(null))
        assertEquals('Counter should have advanced from previous call', ':field1', names.derive(null))
        assertEquals('Counter should have advanced from previous call', ':field2', names.derive(null))
        assertEquals('Counter should have advanced from previous call', ':field3', names.derive(null))
    }
}
