package solutions.bitbadger.documents.groovy

import org.junit.jupiter.api.DisplayName
import org.junit.jupiter.api.Test
//import solutions.bitbadger.documents.DocumentException
import solutions.bitbadger.documents.Parameter
import solutions.bitbadger.documents.ParameterType

import static groovy.test.GroovyAssert.*

/**
 * Unit tests for the `Parameter` class
 */
@DisplayName('JVM | Groovy | Parameter')
class ParameterTest {

    @Test
    @DisplayName("Construction with colon-prefixed name")
    void ctorWithColon() {
        def p = new Parameter(":test", ParameterType.STRING, "ABC")
        assertEquals("Parameter name was incorrect", ":test", p.name)
        assertEquals("Parameter type was incorrect", ParameterType.STRING, p.type)
        assertEquals("Parameter value was incorrect", "ABC", p.value)
    }

    @Test
    @DisplayName("Construction with at-sign-prefixed name")
    void ctorWithAtSign() {
        def p = new Parameter("@yo", ParameterType.NUMBER, null)
        assertEquals("Parameter name was incorrect", "@yo", p.name)
        assertEquals("Parameter type was incorrect", ParameterType.NUMBER, p.type)
        assertNull("Parameter value was incorrect", p.value)
    }

//    TODO: resolve java.base open issue
//    @Test
//    @DisplayName("Construction fails with incorrect prefix")
//    void ctorFailsForPrefix() {
//        assertThrows(DocumentException) { new Parameter("it", ParameterType.JSON, "") }
//    }
}
