package solutions.bitbadger.documents.scala.support

import solutions.bitbadger.documents.jvm.Document
import solutions.bitbadger.documents.support.ThrowawayDatabase
import solutions.bitbadger.documents.support.TypesKt.TEST_TABLE

class JsonDocument(val id: String = "", val value: String = "", val numValue: Int = 0, val sub: SubDocument = null)

object JsonDocument:

  /** Documents to use for testing */
  private val testDocuments = List(
    JsonDocument("one", "FIRST!", 0, null),
    JsonDocument("two", "another", 10, SubDocument("green", "blue")),
    JsonDocument("three", "", 4, null),
    JsonDocument("four", "purple", 17, SubDocument("green", "red")),
    JsonDocument("five", "purple", 18, null))

  def load(db: ThrowawayDatabase, tableName: String = TEST_TABLE): Unit =
    testDocuments.foreach { it => Document.insert(tableName, it, db.getConn) }
